package com.huimv.business.server.service.impl;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.huimv.business.server.dao.entity.FarmDeviceEntity;
import com.huimv.business.server.dao.repo.FarmDeviceRepo;
import com.huimv.business.server.service.IDevice;
import com.huimv.business.utils.TextUtil;
import com.huimv.common.utils.Result;
import com.huimv.common.utils.ResultCode;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.io.UnsupportedEncodingException;
import java.sql.Date;
import java.sql.Timestamp;
import java.util.List;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.biosafety.uface.controller
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2020-12-25
 **/
@Service
@Slf4j
public class DeviceImpl implements IDevice {
    @Autowired
    private FarmDeviceRepo deviceRepo;
    @Autowired
    private TextUtil textUtil;

    @Override
    public Result syncAddFarmDevice(String deviceData) throws UnsupportedEncodingException {
        deviceData = deviceData.replace("data=","");
        deviceData = textUtil.decode(deviceData.replace("%3D","="));
        JSONObject deviceDataJo = JSON.parseObject(deviceData);
//        String encodedText = deviceDataJo.getString("data");
//        System.out.println("encodedText>>"+encodedText);
        FarmDeviceEntity deviceEntity = new FarmDeviceEntity();
        deviceEntity.setDataId(deviceDataJo.getInteger("id"));
        deviceEntity.setDeviceCode(deviceDataJo.getString("deviceCode"));
        deviceEntity.setDeviceName(deviceDataJo.getString("deviceName"));
        deviceEntity.setDeviceType(deviceDataJo.getString("deviceType"));
        deviceEntity.setDownTime(new Timestamp(new  java.util.Date().getTime()));
        deviceEntity.setFactory(deviceDataJo.getString("factory"));
        deviceEntity.setFarmId(deviceDataJo.getInteger("farmId"));
        deviceEntity.setLastTime(new Timestamp(new  java.util.Date().getTime()));
        deviceEntity.setLockinState(2);
        deviceEntity.setMainParams(deviceDataJo.getString("mainParams"));
        deviceEntity.setRecord(deviceDataJo.getString("record"));
        deviceEntity.setState(deviceDataJo.getInteger("state"));
        deviceEntity.setWorker(deviceDataJo.getString("worker"));
        FarmDeviceEntity addEntity = deviceRepo.saveAndFlush(deviceEntity);
        log.info("同步牧场端设备数据>>"+addEntity);
        return new Result(ResultCode.SUCCESS,addEntity);
    }

    @Override
    public Result syncEditFarmDevice(String deviceData){
        JSONObject deviceDataJo = JSON.parseObject(deviceData);
        Integer dataId = deviceDataJo.getInteger("id");
        //查询目标设备数据
        List<Object[]> existList = deviceRepo.getDevice(dataId);
        if(existList.size()>0) {
            Object[] object = existList.get(0);
            Integer id = (Integer) object[0];
            //更新目标设备数据
            FarmDeviceEntity deviceEntity = new FarmDeviceEntity();
            deviceEntity.setId(id);
            deviceEntity.setDataId(deviceDataJo.getInteger("id"));
            deviceEntity.setDeviceCode(deviceDataJo.getString("deviceCode"));
            deviceEntity.setDeviceName(deviceDataJo.getString("deviceName"));
            deviceEntity.setDeviceType(deviceDataJo.getString("deviceType"));
            deviceEntity.setDownTime(new Timestamp(new java.util.Date().getTime()));
            deviceEntity.setFactory(deviceDataJo.getString("factory"));
            deviceEntity.setFarmId(deviceDataJo.getInteger("farmId"));
            deviceEntity.setLastTime(new Timestamp(new java.util.Date().getTime()));
            deviceEntity.setLockinState(2);
            deviceEntity.setMainParams(deviceDataJo.getString("mainParams"));
            deviceEntity.setRecord(deviceDataJo.getString("record"));
            deviceEntity.setState(deviceDataJo.getInteger("state"));
            deviceEntity.setWorker(deviceDataJo.getString("worker"));
            FarmDeviceEntity editEntity = deviceRepo.saveAndFlush(deviceEntity);
            log.info("编辑后的设备数据>>" + editEntity);
            return new Result(ResultCode.SUCCESS,editEntity);
        }else{
            return new Result(ResultCode.SUCCESS);
        }
    }

    @Override
    public Result syncRemoveFarmDevice(String deviceData){
        JSONObject deviceDataJo = JSON.parseObject(deviceData);
        Integer dataId = deviceDataJo.getInteger("dataId");
        //查询目标设备数据
        List<Object[]> existList = deviceRepo.getDevice(dataId);
        if(existList.size()>0) {
            Object[] object = existList.get(0);
            Integer id = (Integer) object[0];
            deviceRepo.deleteById(id);
            return new Result(ResultCode.SUCCESS);
        }else{
            return new Result(10001,"暂无删除设备数据.",false);
        }
    }
}
